<?php
ini_set('display_errors', 'On'); 
error_reporting(E_ALL);	
# to load the changed data into string and send it back to the requesting ajax handler 
# first some inits
#
$SITE			= array();
$SITE['WXsoftware'] = 'WD';
$folderdown		= '../';  // from how many folders up is this script called (normally from gauges/)
#
$pageName		= 'realtimeWD.php';
$pageVersion	= '2.00C 2013-01-31';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;
}
if (!isset($pathString)) {$pathString = '';}
$pathString .= '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile].' -->'.PHP_EOL;
#
chdir ($folderdown);
include('wsSettings.php');
include('wsSettingsWeather.php');
#  for translating the forecast
$lang	= $SITE['lang'];						// default language,
if ($SITE['userChangeLang']) {
	$cookie = $SITE['cookieName']."lang";
	if (isset ($_COOKIE[$cookie])) {			// first check  cookie
		$s=trim(strtolower($_COOKIE[$cookie]));
		if (isset($SITE['installedLanguages'][$s]))	{ 
			$lang = $s; 
		}
	}
	if (isset($_SESSION['lang'])){				//  than check session settings
		$s=trim(strtolower($_SESSION['lang']));
		if (isset($SITE['installedLanguages'][$s]))	{ 
			$lang = $s; 
		}
	}     
	if (isset($_REQUEST['lang'])){				// than check this request settings
		$s=trim(strtolower($_REQUEST['lang']));
		if (isset($SITE['installedLanguages'][$s]))	{ 
			$lang = $s; 
		}
	}
	# now save for further reference
	$SITE['lang']			= $lang;
}

if ($SITE['userChangeUOM']) {
	$cookie = $SITE['cookieName']."uom";
	$temp='x';$baro='x';$wind='x';$rain='x';
	if (isset ($_COOKIE[$cookie])) {
		$uom =  trim($_COOKIE[$cookie]);
		list($temp, $baro, $wind, $rain) = explode ('|',$uom);		
	}
	if (isset($_SESSION['temp']) && $_SESSION['temp'] <> 'x'){ $temp= $_SESSION['temp']; }
	if (isset($_SESSION['baro']) && $_SESSION['baro'] <> 'x'){ $baro= $_SESSION['baro']; }
	if (isset($_SESSION['wind']) && $_SESSION['wind'] <> 'x'){ $wind= $_SESSION['wind']; }
	if (isset($_SESSION['rain']) && $_SESSION['rain'] <> 'x'){ $rain= $_SESSION['rain']; }
	if (isset($_REQUEST['temp']) && $_REQUEST['temp'] <> 'x'){ $temp= $_REQUEST['temp']; }
	if (isset($_REQUEST['baro']) && $_REQUEST['baro'] <> 'x'){ $baro= $_REQUEST['baro']; }
	if (isset($_REQUEST['wind']) && $_REQUEST['wind'] <> 'x'){ $wind= $_REQUEST['wind']; }
	if (isset($_REQUEST['rain']) && $_REQUEST['rain'] <> 'x'){ $rain= $_REQUEST['rain']; }
	if ($temp == 'c' ) 		{$SITE['uomTemp'] ='&deg;C';} 	elseif ($temp == 'f' ) 	{$SITE['uomTemp'] = '&deg;F';} 	else 	{$temp ='x';}
	if ($baro == 'hpa' ) 	{$SITE['uomBaro'] =' hPa';} 	elseif ($baro == 'mb' )	{$SITE['uomBaro'] = ' mb';} 	elseif	($baro == 'inhg' )	{$SITE['uomBaro'] = ' inHg';} else {$baro='x';}
	if ($wind == 'kmh' )	{$SITE['uomWind'] =' km/h';} 	elseif ($wind == 'kts' ){$SITE['uomWind'] = ' kts';} 	elseif	($wind == 'ms' )	{$SITE['uomWind'] = ' m/s';}  elseif ($wind == 'mph' ) {$SITE['uomWind'] = ' mph';} else {$wind='x';}
	if ($rain == 'mm' ) 	{$SITE['uomRain'] =' mm';} 		elseif ($rain == 'in' ) {$SITE['uomRain'] = ' in';} 	else 	{$rain='x';}
	}
#
# read file into string
if (isset ($SITE['steelFile'])) { 
	$fileName = $SITE['steelFile'];
}  else {
	echo 'error - no input-file specified - program halted'; exit;
}
#												strJson contents: {"date":"17:29","temp":"27,0","tempTL":"11,0",
$strJson 	= file_get_contents($fileName);
$arrVars	= json_decode($strJson, true);
#
if ( isset($_GET['debug']) ) {
	echo '<pre>';
	echo PHP_EOL.'$SITE["WXsoftware"] = '.$SITE['WXsoftware'].PHP_EOL;
	echo 'Script realtimeWD.php = '.$SITE['wsModules']['realtimeWD.php'] .PHP_EOL;
	echo 'input string = '.$strJson.PHP_EOL;
	echo 'processed to input array ='.PHP_EOL;
	var_dump(json_decode($strJson, true));
	exit;
}
# 											clean up units
$from 					= array ('&deg;','');
$arrVars['tempunit']	= str_replace ($from, '', $arrVars['tempunit']);
$arrVars['windunit']	= str_replace ('r', '', $arrVars['windunit']);
#
include_once($SITE['functions']);
include_once($SITE['langFunc']);
$missing = '';
$fromTemp	= $arrVars ['tempunit'];
$fromWind	= $arrVars ['windunit'];
$fromRain	= $arrVars ['rainunit'];
$fromBaro	= $arrVars ['pressunit'];
#
#	$arrVars['xxx']

$arrOut['date']			= $arrVars['date'];													// "date":"21:00",
#$arrOut["dateFormat"] 	= 'd/m/j';												 
$arrOut['temp']			= (string)wsConvertTemperature($arrVars['temp'], $fromTemp);		// "temp":"6.2",
$arrOut['tempTL']		= (string)wsConvertTemperature($arrVars['tempTL'], $fromTemp);		// "tempTL":"3.7",
$arrOut['tempTH']		= (string)wsConvertTemperature($arrVars['tempTH'], $fromTemp);		// "tempTH":"6.7",
$arrOut['intemp']		= (string)wsConvertTemperature($arrVars['intemp'], $fromTemp);		// "intemp":"20.8",
$arrOut['dew']			= (string)wsConvertTemperature($arrVars['dew'], $fromTemp);			// "dew":"5.0",
$arrOut['dewpointTL']	= (string)wsConvertTemperature($arrVars['dewpointTL'], $fromTemp);	// "dewpointTL":"3.0",
$arrOut['dewpointTH']	= (string)wsConvertTemperature($arrVars['dewpointTH'], $fromTemp);	// "dewpointTH":"5.3",
$arrOut['apptemp']		= (string)wsConvertTemperature($arrVars['apptemp'], $fromTemp);		// "apptemp":"4.4",
$arrOut['apptempTL']	= (string)wsConvertTemperature($arrVars['apptempTL'], $fromTemp);	// "apptempTL":"2.4",
$arrOut['apptempTH']	= (string)wsConvertTemperature($arrVars['apptempTH'], $fromTemp);	// "apptempTH":"8.2",
$arrOut['wchill']		= (string)wsConvertTemperature($arrVars['wchill'], $fromTemp);		// "wchill":"6.2",
$arrOut['wchillTL']		= (string)wsConvertTemperature($arrVars['wchillTL'], $fromTemp);	// "wchillTL":"1.9",
$arrOut['heatindex']	= (string)wsConvertTemperature($arrVars['heatindex'], $fromTemp);	// "heatindex":"6.2",
$arrOut['heatindexTH']	= (string)wsConvertTemperature($arrVars['heatindexTH'], $fromTemp);	// "heatindexTH":"6.7",
$arrOut['humidex']		= (string)wsConvertTemperature($arrVars['humidex'], $fromTemp);		// "humidex":"5.5",

$arrOut['wlatest']		= (string)wsConvertWindspeed($arrVars['wlatest'], $fromWind);		// "wlatest":"0.0",
$arrOut['wspeed']		= (string)wsConvertWindspeed($arrVars['wspeed'], $fromWind);		// "wspeed":"0.0",
$arrOut['wgust']		= (string)wsConvertWindspeed($arrVars['wgust'], $fromWind);			// "wgust":"0.0",
$arrOut['wgustTM']		= (string)wsConvertWindspeed($arrVars['wgustTM'], $fromWind);		// "wgustTM":"7.9",

$arrOut['bearing']		= (string)$arrVars['bearing'];										// "bearing":"233",
$arrOut['avgbearing']	= (string)$arrVars['avgbearing'];									// "avgbearing":"225.0",

$arrOut['press']		= (string)wsConvertBaro($arrVars['press'], $fromBaro);				// "press":"1018.6",
$arrOut['pressTL']		= (string)wsConvertBaro($arrVars['pressTL'], $fromBaro);			// "pressTL":"1017.4",
$arrOut['pressTH']		= (string)wsConvertBaro($arrVars['pressTH'], $fromBaro);			// "pressTH":"1019.6",
$arrOut['pressL']		= (string)wsConvertBaro($arrVars['pressL'], $fromBaro);				// "pressL":"976.1",
$arrOut['pressH']		= (string)wsConvertBaro($arrVars['pressH'], $fromBaro);				// "pressH":"1031.9",

$arrOut['rfall']		= (string)wsConvertRainfall($arrVars['rfall'], $fromRain);			// "rfall":"0.00",
$arrOut['rrate']		= (string)wsConvertRainfall($arrVars['rrate'], $fromRain);			// "rrate":"0.0",
$arrOut['rrateTM']		= (string)wsConvertRainfall($arrVars['rrateTM'], $fromRain);		// "rrateTM":"0.0",

$arrOut['hum']			= (string)$arrVars['hum'];											// "hum":"91",
$arrOut['humTL']		= (string)$arrVars['humTL'];										// "humTL":"91",
$arrOut['humTH']		= (string)$arrVars['humTH'];										// "humTH":"96",
$arrOut['inhum']		= (string)$arrVars['inhum'];										// "inhum":"32",

$arrOut['SensorContactLost']= (string)$arrVars['SensorContactLost'];						// "SensorContactLost":"0",

$from 		= array ('hrs.', 'temp.',' windy');
$to   		= array ('hours', 'temperature', '.windy');
$value 		= str_replace ($from, $to,trim($arrVars['forecast']) );		// "forecast":"partly cloudy with little temp. change.",

$arrVantage	= explode('.',$value.'.');
$text		= '';
$end		= count($arrVantage);
for ($i=0;$i < $end; $i++){
	$strng	= trim($arrVantage[$i]);
	if ((isset($strng) && (strlen($strng) >= 1))) {
		$text.='&nbsp;&nbsp;'.langtransstr(ucfirst($strng));
		}
}
$arrOut['forecast']		= $text;		// 

$arrOut['tempunit']		= (string)str_replace('&deg;','',$SITE['uomTemp']);				// "tempunit":"C",
$arrOut['windunit']		= (string)trim($SITE['uomWind']);								// "windunit":"kmh",
$arrOut['pressunit']	= (string)trim($SITE['uomBaro']);								// "pressunit":"hPa",
$arrOut['rainunit']		= (string)trim($SITE['uomRain']);								// "rainunit":"mm",
$arrOut['temptrend']	= (string)wsConvertTempRate($arrVars['temptrend'], $fromTemp);	// "temptrend":"-0.2",
$arrOut['TtempTL']		= $arrVars['TtempTL'];									// "TtempTL":"03:21",
$arrOut['TtempTH']		= $arrVars['TtempTH'];									// "TtempTH":"15:14",
$arrOut['TdewpointTL']	= $arrVars['TdewpointTL'];								// "TdewpointTL":"03:21",
$arrOut['TdewpointTH']	= $arrVars['TdewpointTH'];								// "TdewpointTH":"15:14",
$arrOut['TapptempTL']	= $arrVars['TapptempTL'];								// "TapptempTL":"05:45",
$arrOut['TapptempTH']	= $arrVars['TapptempTH'];								// "TapptempTH":"15:01",
$arrOut['TwchillTL']	= $arrVars['TwchillTL'];								// "TwchillTL":"15:14",
$arrOut['TheatindexTH']	= $arrVars['TheatindexTH'];								// "TheatindexTH":"15:14",
$arrOut['TrrateTM']		= $arrVars['TrrateTM'];									// "TrrateTM":"00:00",
$arrOut['ThourlyrainTH']= $arrVars['ThourlyrainTH'];							// "ThourlyrainTH":"02:37",

$arrOut['LastRained']	= (string)$arrVars['LastRainTipISO'];					// "LastRainTipISO":"15/2/2013 05:12",

$arrOut['hourlyrainTH']	= (string)wsConvertRainfall($arrVars['hourlyrainTH'], $fromRain);// "hourlyrainTH":"0.0",

$arrOut['ThumTL']		= $arrVars['ThumTL'];									// "ThumTL":"14:22",
$arrOut['ThumTH']		= $arrVars['ThumTH'];									// "ThumTH":"03:53",
$arrOut['TpressTL']		= $arrVars['TpressTL'];									// "TpressTL":"00:00",
$arrOut['TpressTH']		= $arrVars['TpressTH'];									// "TpressTH":"12:03",

$arrOut['presstrendval']= (string)wsConvertBaro($arrVars['presstrendval'], $fromBaro);	// "presstrendval":"+0.4 ",

$arrOut['Tbeaufort']	= (string)$arrVars['Tbeaufort'];						// "Tbeaufort":"2",
$arrOut['TwgustTM']		= $arrVars['TwgustTM'];									// "TwgustTM":"08:22",

$arrOut['windTM']		= (string)wsConvertWindspeed($arrVars['windTM'], $fromWind);	// "windTM":"5.0",

$arrOut['bearingTM']	= (string)$arrVars['bearingTM'];								// ""bearingTM":"227",
$arrOut['timeUTC']		= $arrVars['timeUTC'];											// "timeUTC":"2013,02,16,20,00,02",
$arrOut['BearingRangeFrom10']	= (string)$arrVars['BearingRangeFrom10'];				// "BearingRangeFrom10":"232",
$arrOut['BearingRangeTo10']		= (string)$arrVars['BearingRangeTo10'];					// "BearingRangeTo10":"232",
$arrOut['UV']			= (string)$arrVars['UV'];										// "UV":"0.0",
$arrOut['SolarRad']		= (string)$arrVars['SolarRad'];									// "SolarRad":"0",
$arrOut['CurrentSolarMax']= (string)$arrVars['CurrentSolarMax'];						// "CurrentSolarMax":"0",
$arrOut['SolarTM']		= (string)$arrVars['SolarTM'];									// "SolarTM":"100",
#$arrOut['domwinddir']	= (string)$arrVars['domwinddir'];								// "domwinddir":"SW",
#$arrOut['WindRoseData']	= $arrVars['WindRoseData'];		// "WindRoseData":[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,4.0,0.0,0.0,0.0,0.0,0.0],
#$arrOut['windrun']		= (string)wsConvertWindspeed($arrVars['windrun'], $fromWind);	// "windrun":"33,4",
$arrOut['version']		= (string)$arrVars['version'];									// "version":"10.37R",
$arrOut['build']		= (string)$arrVars['build'];									// "build":"41",
$arrOut['ver']			= (string)'9';													// "ver":"8"
#
# antwoord aan javascript geven
header("Content-Type: text/plain; charset=ISO-8859-1");
echo json_encode($arrOut);
#echo $string;
?>